package com.ether;

import org.apache.commons.lang.ArrayUtils;
import org.jetbrains.annotations.NotNull;

import java.util.ArrayList;
import java.util.List;

/**
 * @author vmipsl
 * @date 09 sept. 2011
 */
public abstract class EtherHelper
{
    /**
     * This method returns the list with the second values of a list of <Pair>
     *
     * @param pairList
     * @return
     */
    @NotNull
    public static <T1, T2> List getSecondValues( @NotNull final List<Pair<T1, T2>> pairList )
    {
        final List secondValues = new ArrayList<T2>( pairList.size() );
        for( final Pair pair : pairList )
            secondValues.add( pair.getSecondValue() );

        return secondValues;
    }

    public static double[] convertListDoubleToDoubleArray(@NotNull final List<Double> list)
    {
        Double[] doubleArray = new Double[list.size()];
        doubleArray = list.toArray( doubleArray );
        return ArrayUtils.toPrimitive( doubleArray );
    }

}
