package com.ether;

import com.medias.database.objects.Parametre;
import com.medias.database.objects.Plateforme;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.Date;
import java.util.List;

/**
 * @author vmipsl
 * @date 07 mar 2011
 */
public interface EtherService
        extends Service
{
    @Nullable
    List<Plateforme> getAllPlateforms()
            throws ServiceException;

    @Nullable
    Plateforme getPlateformById( @Nullable final Integer plateformId )
            throws ServiceException;

    @Nullable
    Parametre getParameterById( @Nullable final Integer parameterId )
            throws ServiceException;

    @Nullable
    List<Parametre> getParametersByPlateformId( @NotNull final Integer plateformId )
            throws ServiceException;

    @NotNull
    <T1, T2, T3> Data<T1[], T2[], T3[]> getListsByPlateformByParameterByPeriodForTimeSerie( @NotNull final Integer plateformId, @NotNull final Integer parameterId, @Nullable final Date dateBegin, @Nullable final Date dateEnd )
            throws ServiceException;

    @NotNull
    <T1, T2, T3> Data<T1[], T2[], T3[]> getArraysByPlateformByParameterByPeriodFor2D( @NotNull final Integer plateformId, @NotNull final Integer parameterId, @Nullable final Date dateBegin, @Nullable final Date dateEnd )
            throws ServiceException;

    @NotNull
    <T1, T2, T3> Data<List<T1>, List<T2>, List<T3>> getListsByPlateformByParameterByPeriodFor2D( @NotNull final Integer plateformId, @NotNull final Integer parameterId, @Nullable final Date dateBegin, @Nullable final Date dateEnd )
            throws ServiceException;

    @NotNull
    Integer getNumberValuesByPlateformByParameterByPeriod( @NotNull final List<Pair> pairs, @Nullable final Date beginDate, @Nullable final Date endDate )
            throws ServiceException;
}
