package com.ether;

import gov.noaa.pmel.sgt.LineAttribute;
import gov.noaa.pmel.util.GeoDateArray;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;
import org.junit.Test;

import javax.imageio.ImageIO;
import javax.swing.*;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.Serializable;
import java.text.ParseException;
import java.util.Date;

/**
 * @author vmipsl
 * @date 2011
 */
public class EtherTest
{
    /**
     * @param day : jour au format yyyy-MM-dd
     */
//    @NotNull
//    protected List<Data> createDataList( @NotNull final Integer sizeList, @Nullable String day )
//            throws ParseException
//    {
//        if( null == day )
//            day = "2009-07-13";
//
//        final List<Data> dataList = new ArrayList<Data>();
//        for( int i = 0; i < sizeList; i++ )
//        {
//            final String dateString = day + " " + i + ":32";
//            final Date date = DateHelper.parseDate( dateString, DateHelper.ENGLISH_DATE_PATTERN );
//
//            final Data data = new Data();
//            data.setDate( date );
//            data.setValue( i );
//
//            dataList.add( data );
//        }
//        return dataList;
//    }

    /**
     * @param day : jour au format yyyy-MM-dd
     */
    @NotNull
    protected GeoDateArray createTimeArray( @NotNull final Integer size, @Nullable String day )
            throws ParseException
    {
        if( null == day )
            day = "2009-07-13";

        final Date[] dates = new Date[size];
        for( int i = 0; i < size; i++ )
        {
            final String dateString = day + ' ' + i + ":32";
            final Date date = DateHelper.parseDate( dateString, DateHelper.ENGLISH_DATE_PATTERN );
            dates[i] = date;
        }
        return new GeoDateArray( dates );
    }

    @NotNull
    protected double[] createDataArray( @NotNull final Integer size, @NotNull final Integer begin )
            throws ParseException
    {
        final double[] datas = new double[size];
        for( int i = 0; i < size; i++ )
        {
            datas[i] = Double.valueOf( i + begin );
        }
        return datas;
    }

    protected void copyToFile( @NotNull final JFrame frame, @NotNull final String fileName )
    {
        final BufferedImage image = new BufferedImage( frame.getWidth(), frame.getHeight(), BufferedImage.TYPE_INT_RGB );

        final Graphics2D g2 = image.createGraphics();
        frame.paint( g2 );
        g2.dispose();

        try
        {
            final File out = new File( fileName );
            ImageIO.write( image, "JPEG", out );
        }
        catch( Exception e )
        {
        }
    }

    protected <T extends Serializable> void displayArray( @NotNull final T[] objectsArray )
    {
        for( int i = 0; i < objectsArray.length; i++ )
            System.out.println( objectsArray[i].toString() );
    }

}
